#import os
from es_C import *

class SourceServer:
  def cmd(self, command):
    InsertServerCommand(command)
    return
  def queuecmd(self, command):
    ServerCommand(command)
    return
  def printmsg(self, msg):
    printmsg(msg)
  def log(self, log):
    log(log)
# instantiate Server class
server = SourceServer()

# need a class for ServerVariables
#   calls back into Valve Plugin for lookup
#   calls back into Valve Plugin for set
class SourceServerVariables:
  def __getitem__(self, var):
    return getString(var)
  def __setitem__(self, var, value):
    if (type(value) == int):
      setInt(var, value)
    elif (type(value) == str ):
      setString(var, value)
    elif (type(value) == float):
      setFloat(var, value)
    return
# instantiate ServerVariables class
server_var = SourceServerVariables()

class SourceEventVariables:
  def __getitem__(self, var):
    return getEventInfo(var)
event_var = SourceEventVariables()

# default output function
def output(string):
  print string

class AddonManager:
  def __init__(self):
    self.AddonList = []
    self.EventListeners = {}
    self.Blocks = {}
  def load(self, addon):
    name = addon.__name__
    if name.find(".") >= 0:
      name = name[name.find(".")+1:]
    if (addon not in self.AddonList):
      self.AddonList.append(addon)
      if addon.__dict__.has_key("load"): 
        addon.load()
      if addon.__dict__.has_key("enable"): 
        addon.enable()
      print "Loaded:" + name
    else:
      print "Already loaded:" + name
  def unload(self, addon):
    self.AddonList.remove(addon)
    addon.disable()
    addon.unload()
  def disable(self, addon):
    addon.disable()
  def enable(self, addon):
    addon.enable()
  def list(self, outputfunc=output):
    for x in self.AddonList:
      outputfunc("  Name: %s %s\n  Desc: %s\nAuthor: %s\nContact: %s\n\n" % (x.Name, x.Version, x.Description, x.Author, x.Contact))
  # register a listener for a specific event
  def registerForEvent(self, listener, eventname, callback):
    if not self.EventListeners.has_key(eventname):
      self.EventListeners[eventname] = {}
    self.EventListeners[eventname][listener] = callback
  # unregister a listener
  def unregisterForEvent(self, listener, eventname):
    if not self.EventListeners.has_key(eventname):
      return
    if self.EventListeners[eventname].has_key(listener):
      del self.EventListeners[eventname][listener]
  # triggers an event
  # pygo es.addons.triggerEvent('round_start', None)
  def triggerEvent(self, eventname, eventinfo):
    if not self.EventListeners.has_key(eventname):
      return
    for listener in self.EventListeners[eventname]:
      if not listener.__dict__.has_key('disable') or not listener.disabled:
        self.EventListeners[eventname][listener](eventinfo)
  def tick(self):
    return
  def callBlock(self, blockname):
    # TODO: Shouldn't call blocks for disabled addons
    if not self.Blocks.has_key(blockname):
      return
    self.Blocks[blockname]()
  def registerBlock(self, addonname, blockname, callback):
    self.Blocks[addonname + "/" + blockname] = callback
  def unregisterBlock(self, addonname, blockname):
    if not self.Blocks.has_key(addonname + "/" + blockname):
      return
    del self.Blocks[addonname + "/" + blockname]

# instantiate AddonManager
addons = AddonManager()

# es_load:
#   open(r"<script-path>/__init__.py", 'a').close()  # touches the script
#   touch <script>/__init__.py
#   import <script>
#   for each function:
#       put it into a blocklist dictionary
#   pygo <script>.load()
def loadModuleAddon(modulename):
  #directory = "%s/%s
  #if os.path.exists(
  open(r"%s/%s/__init__.py" % (server_var['eventscripts_addondir'], modulename), 'a').close()
  endname = modulename[modulename.rfind("/")+1:]  
  importname = modulename.replace("/", ".") + "." + endname
  try:
    newaddon = __import__(importname)
    if newaddon in addons.AddonList:
      print "Addon %s already loaded." % (modulename)
      return
  except ImportError, blah:
      print "Can't load addon (%s): %s" % (modulename, blah)
      return
  # loop deep so we can import the subsubscript if there is one.
  # Need to recurse down a level for each . in the module name
  # e.g. mymodule.sub1.sub2 needs to loop down to sub2
  for j in importname[importname.find(".")+1:].split("."):
    newaddon = newaddon.__dict__[j]
  for f in newaddon.__dict__:
    # loop through every function and register them as blocks
    # TODO: restrict it to commands with no arguments
    if type(newaddon.__dict__[f]).__name__ == "function":
      if f[0:1] != "_":
        addons.registerBlock(modulename, f, newaddon.__dict__[f])
        addons.registerForEvent(newaddon, f, newaddon.__dict__[f])
  addons.load(newaddon)

def unloadModuleAddon(modulename):
    # test
    print modulename

# TODO:
# es_unload:
#   pygo <script>.unload()
#   del sys.modules['script']
#   for each block in blocklist:
#      if from the script:
#         delete block


dbgmsg(0,"es.py loaded.")
